expectvalue %String
doit
RcQueueEntry _newKernelSubclass: 'RcQueueEntry2020'
  instVarNames: #()
  classVars: #()
  classInstVars: #()
  poolDictionaries: #[]
  inDictionary: Globals
  constraints: #[]
  instancesInvariant: false
  isModifiable: false
  reservedOop: nil
%

removeallmethods RcQueueEntry2020
removeallclassmethods RcQueueEntry2020

! ------------------- Class methods for RcQueueEntry2020
category: 'Instance Creation'
classmethod: RcQueueEntry2020
newWithValue: anObject sequenceNumber: aSmallInt
"Return a new instance of the receiver containing anObject as the value and
 aSmallInt as the sequence number.  This method also fills in the createTime
 and createTimeUs instance variables with the current time in gmt2020 format."

<primitive: 586>
aSmallInt _validateClass: SmallInteger .
^self _primitiveFailed: #newWithValue:sequenceNumber: .
%
! ------------------- Instance methods for RcQueueEntry2020
category: 'Comparing'
method: RcQueueEntry2020
createTimeAsGmt2005

"Return the create time in gmt2005 format, which we always use for createTime."
^createTime + 473294832
%
category: 'Comparing'
method: RcQueueEntry2020
createTimeAsGmt2020

"Return the create time in gmt2020 format, which we always use for createTime."
^createTime
%
category: 'Comparing'
method: RcQueueEntry2020
createTimeAsGmt95

"Return the create time in gmt2005 format, which we always use for createTime."
^createTime + 788914032
%
category: 'Comparing'
method: RcQueueEntry2020
isOlderThan: anotherElementOrEntry

"Compare the creation time of this object to that of anotherElementOrEntry,
 which must be an instance of RcQueueElement or RcQueueEntry object.  
 Answers true if this object is older than anotherElementOrEntry or 
 if anotherElementOrEntry is nil.   Answers false otherwise."

| crTime2020 |
anotherElementOrEntry == nil
  ifTrue:[^true].
crTime2020 := anotherElementOrEntry createTimeAsGmt2020 .
^(createTime == anotherElementOrEntry createTimeAsGmt2020)
  ifTrue:[createTimeUs < anotherElementOrEntry createTimeUs]
  ifFalse:[createTime < crTime2020].
%

